// eX^g (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];
unsigned char pentapcm[0x2400];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_offset], 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	int find1=1;
	int find2=1;
	int pentaflag=0;

	struct fpos md[] =
	{
		{ 0x1d, 0x02, 0x0000, 0x0c00 },	// I[vjO
		{ 0x08, 0x02, 0x0000, 0x0800 },	// BGM 1
		{ 0x08, 0x04, 0x0000, 0x0800 },	// BGM 2
		{ 0x0f, 0x02, 0x0000, 0x0800 },	// BGM 3
		{ 0x0f, 0x04, 0x0000, 0x0800 },	// BGM 4
		{ 0x32, 0x02, 0x0000, 0x0800 },	// {X
		{ 0x16, 0x02, 0x0000, 0x0800 },	// LSP?/RSP?
		{ 0x16, 0x04, 0x0000, 0x0800 },	// IDOL
		{ 0x2b, 0x02, 0x0000, 0x0c00 },	// y^hS
		{ 0x24, 0x02, 0x0000, 0x0c00 },	// GfBO
		{ 0x32, 0x03, 0x0200, 0x0100 },	// t@t@[
		{ 0x32, 0x03, 0x0300, 0x0100 },	// Q[I[o[
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	struct fpos pd1[] =
	{
		{ 0x1d, 0x05, 0x0300, 0x0d00 },	// DEMON
		{ 0x20, 0x02, 0x0300, 0x0d00 },	// KAMIKIRIN
		{ 0x22, 0x04, 0x0300, 0x0d00 },	// HARPY
		{ 0x25, 0x01, 0x0300, 0x0d00 },	// SKELETON HEAD
		{ 0x27, 0x03, 0x0300, 0x0d00 },	// KUMON MASATO
		{ 0x29, 0x05, 0x0300, 0x0d00 },	// GHOST
		{ 0x2c, 0x02, 0x0300, 0x0d00 },	// TOMOKO
		{ 0x2e, 0x04, 0x0300, 0x0d00 },	// OTAKE
		{ 0x4f, 0x01, 0x0300, 0x0d00 },	// RSP-BIG
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	struct fpos pd2[] =
	{
		{ 0x39, 0x02, 0x0000, 0x1000 },	// ӂ߁[
		{ 0x40, 0x02, 0x0000, 0x1000 },	// ǂ
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		if ((disk.ReadID(0,buff,4*16)>>2)==5 && find2)
		{
			printf("fBXN2F܂.\n");
			find2--;
			disk.SetRecordRange(0x01,0x05);
//			fcut("INFO", 0x01, 0x00, 0x01, 0x01, 0x03, 0x0000, 0x1400);
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"TS%03d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x03, md[i].ofs, md[i].size);
			}
			for (i=0; pd2[i].sec; i++)
			{
				sprintf(fname,"PCM%02d",i);
				fcut(fname, pd2[i].trk, pd2[i].trk>>1, pd2[i].trk&1, pd2[i].sec, 0x03, pd2[i].ofs, pd2[i].size);
			}
			if (pentaflag) {
				// y^hSpPCM㔼
				disk.ReadDATA( 0x00, 0x00, 0x00, 0x01, 0x03, &pentapcm[0x1400], 0x1000);
				fsave("PCM11", pentapcm, 0x2400);
				pentaflag--;
			}
		}
		else if (find1)
		{
			printf("fBXN1F܂.\n");
			find1--;
			disk.SetRecordRange(0x01,0x05);
			fcut("PROG", 0x01, 0x00, 0x01, 0x01, 0x03, 0x0000, 0x4c00);
			for (i=0; pd1[i].sec; i++)
			{
				sprintf(fname,"PCM%02d",i+2);
				fcut(fname, pd1[i].trk, pd1[i].trk>>1, pd1[i].trk&1, pd1[i].sec, 0x03, pd1[i].ofs, pd1[i].size);
			}
			// y^hSpPCMO
			disk.ReadDATA( 0x08, 0x04, 0x00, 0x01, 0x03, &pentapcm[0x0000], 0x1400);
			pentaflag++;
		}
	}
	return 0;
}

